//!	EOS_HandlerBase.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_HandlerBase_h_
#define _EOS_HandlerBase_h_


//--------------------------- include section -----------------------
#include "EOS_Macros.h"
#include "EOS_Delete.h"


//--------------------------- class definition ----------------------
//! the class CEOS_HandlerBase is a template class which is able
//! to handle events (CEOS_Event)\n
//! the class is a template class to be able to call member function
//! of the handed over class type
//! \code
//! class CMyHandlerBase : public CEOS_HandlerBase<CMyHandlerBase>
//! {
//! 	[...]
//! };
//! \endcode
template <typename A1=void,
          typename A2=void,
          typename A3=void,
          typename A4=void,
          typename A5=void,
          typename A6=void,
          typename A7=void,
          typename A8=void,
          typename A9=void,
          typename A10=void>
class CEOS_HandlerBase :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    //! base member function, which will call the function in the
    //! derived class
    virtual void onExecute(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with 9 template arguments
template <typename A1,
          typename A2,
          typename A3,
          typename A4,
          typename A5,
          typename A6,
          typename A7,
          typename A8,
          typename A9>
class CEOS_HandlerBase<A1,A2,A3,A4,A5,A6,A7,A8,A9> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute(A1,A2,A3,A4,A5,A6,A7,A8,A9) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with 8 template arguments
template <typename A1,
          typename A2,
          typename A3,
          typename A4,
          typename A5,
          typename A6,
          typename A7,
          typename A8>
class CEOS_HandlerBase<A1,A2,A3,A4,A5,A6,A7,A8> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute(A1,A2,A3,A4,A5,A6,A7,A8) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with 7 template arguments
template <typename A1,
          typename A2,
          typename A3,
          typename A4,
          typename A5,
          typename A6,
          typename A7>
class CEOS_HandlerBase<A1,A2,A3,A4,A5,A6,A7> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute(A1,A2,A3,A4,A5,A6,A7) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with 6 template arguments
template <typename A1,
          typename A2,
          typename A3,
          typename A4,
          typename A5,
          typename A6>
class CEOS_HandlerBase<A1,A2,A3,A4,A5,A6> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute(A1,A2,A3,A4,A5,A6) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with 5 template arguments
template <typename A1,
          typename A2,
          typename A3,
          typename A4,
          typename A5>
class CEOS_HandlerBase<A1,A2,A3,A4,A5> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute(A1,A2,A3,A4,A5) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with 4 template arguments
template <typename A1,
          typename A2,
          typename A3,
          typename A4>
class CEOS_HandlerBase<A1,A2,A3,A4> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute(A1,A2,A3,A4) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with 3 template arguments
template <typename A1,
          typename A2,
          typename A3>
class CEOS_HandlerBase<A1,A2,A3> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute(A1,A2,A3) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with 2 template arguments
template <typename A1,
          typename A2>
class CEOS_HandlerBase<A1,A2> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute(A1,A2) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with 1 template argument
template <typename A1>
class CEOS_HandlerBase<A1> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute(A1) = 0;
};


//########################### specialized template ##################
//--------------------------- class definition ----------------------
//! with no template arguments
template <>
class CEOS_HandlerBase<> :
        public CEOS_Delete
{
//--------------------------- construction --------------------------
    CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(CEOS_HandlerBase);

//--------------------------- virtual public access -----------------
public:
    // onExecute ----------------------------------------------------
    virtual void onExecute() = 0;
};






#endif
