//!	EOS_Interrupt.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_Interrupt_h_
#define _EOS_Interrupt_h_


//--------------------------- include section -----------------------
#include "types.h"
#include "EOS_Event.h"


//--------------------------- class definition ----------------------
//! this class represents an abstraction of an interrupt source
class CEOS_Interrupt
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! \internal
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CEOS_Interrupt);


//--------------------------- public data ---------------------------
public:
    // m_InterruptEvent ---------------------------------------------
    //! is the CEOS_Event, that will be triggered when the ISR
    //! function is called. This must be programmed internally
    CEOS_Event<> m_InterruptEvent;
};


#endif
