//!	EOS_InterruptFalling.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_InterruptFalling_h_
#define _EOS_InterruptFalling_h_


//--------------------------- include section -----------------------
#include "types.h"
#include "EOS_Interrupt.h"


//--------------------------- class definition ----------------------
//! this class represents an abstraction of an interrupt source, that
//! will be triggered on a falling edge
class CEOS_InterruptFalling :
        virtual public CEOS_Interrupt
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! \internal
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CEOS_InterruptFalling);


//--------------------------- public virtual access -----------------
public:
    // enableInterruptFalling ---------------------------------------
    //! enables the falling edge interrupt
    virtual void enableInterruptFalling(bool_t bEnabled) = 0;
};


#endif
