/*	def.h
*/


//--------------------------- inclusion guards ----------------------
#ifndef _def_h_
#define _def_h_


//--------------------------- compiler definitions ------------------
	// PUBLIC_FCT ---------------------------------------------------
	//! for defining public functions
	#define PUBLIC_FCT extern

	// PRIVATE_FCT --------------------------------------------------
	//! for defining private functions
	#define PRIVATE_FCT static

	// PUBLIC_DATA --------------------------------------------------
	//! for defining public variables
	#define PUBLIC_DATA extern

	// PRIVATE_DATA -------------------------------------------------
	//! for defining private variabe
	#define PRIVATE_DATA static



//--------------------------- public definitions --------------------
	// OK -----------------------------------------------------------
	//! return value for functions, which have to return ERRORLEVELS
	#define OK 0
	
	// FAILURE ------------------------------------------------------
	//! return value for functions, which have to return ERRORLEVELS
	#define FAILURE -1
	
	// TRUE ---------------------------------------------------------
	// boolean value for logic
#ifndef TRUE
	#define TRUE 1
#endif
	
	// FALSE --------------------------------------------------------
	//! boolean value for logic
#ifndef FALSE
	#define FALSE 0
#endif
	
	// HIGH ---------------------------------------------------------
	//! boolean value for signal levels
#ifndef HIGH
	#define HIGH 1
#endif
	
	// LOW ----------------------------------------------------------
	//! boolean value for signal levels
#ifndef LOW
	#define LOW 0
#endif
	
	// PI -----------------------------------------------------------
	//! the constant pi
	#define PI 3.1415926535897932384626433832795
	
	// NULL ---------------------------------------------------------
	//! used from stdio.h
#ifndef NULL
	#ifdef  __cplusplus
		#define NULL 0
	#else
		#define NULL ((void *)0)
	#endif
#endif
	




#endif
